"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
// copy from thrift/parseEnum.ts
const debug_1 = tslib_1.__importDefault(require("debug"));
const enumDebugger = debug_1.default('parser:protobuf-enum');
function parseEnum(codes, _options) {
    const name = /^enum\s+([\w\d_]+)(?:\s+)?{/.exec(codes[0].trim())[1];
    const properties = {};
    const propertyLines = codes.filter(d => !!d.trim()).slice(1, codes.length - 1);
    for (let i = 0; i < propertyLines.length; i++) {
        const mc = /([\w\d_]+)\s*\=\s*(\d+)[\s,;]?(?:[\s]+)?(?:(?:(?:#+)\s*(.+))|(?:\/{2,}(?:\s+)?(.+)?))?/.exec(propertyLines[i]);
        /* istanbul ignore if */
        if (mc === null) {
            continue;
        }
        const comment = (mc[3] || mc[4] || '').trim();
        const key = mc[1].trim();
        const value = Number(mc[2]);
        /* istanbul ignore if */
        if (isNaN(value) || !key) {
            enumDebugger('continue: %o', mc);
            continue;
        }
        properties[key] = {
            value,
            comment
        };
    }
    return {
        name,
        properties
    };
}
exports.parseEnum = parseEnum;
