import { RpcEntity, CMDOptions, InterfaceEntity, EnumEntity } from '../interfaces';
export declare function print(entity: RpcEntity | undefined, options: Partial<CMDOptions> & Pick<CMDOptions, 'root' | 'tsRoot'>, includeMap: {
    [key: string]: RpcEntity;
}): Promise<void>;
/**
 * 输出 enums
 *
 * @export
 * @param {RpcEntity} entity thrift entity
 * @param {boolean=false} noExport  是否暴露
 * @returns {string}
 */
export declare function printEnums(enums: EnumEntity[], noExport?: boolean): string;
/**
 * 输出 interfaces，不同于 thrift 版本，需要额外处理嵌套声明
 *
 * @export
 * @param {Pick<RpcEntity, 'interfaces' | 'ns'>} entity thrift entity
 * @param {boolean=false} noExport  是否暴露
 * @returns {string}
 */
export declare function printInterfaces(entity: Pick<RpcEntity, 'interfaces'>, noExport?: boolean): string;
/**
 * 输出 typedef
 *
 * @export
 * @param {RpcEntity} entity
 * @returns {string}
 */
export declare function printTypeDefs(entity: RpcEntity): string;
/**
 * 这个函数用来修复类型是通过 import 导入的名称
 *
 * @export
 * @param {string} content
 * @param {RpcEntity} entity
 * @param {{ [key: string]: RpcEntity }} includeMap
 * @returns {string}
 */
export declare function fixIncludeNamespace(content: string, entity: RpcEntity, includeMap: {
    [key: string]: RpcEntity;
}): string;
export declare function getInternalInterfacesAndEnums(entity: InterfaceEntity, enums?: EnumEntity[], interfaces?: InterfaceEntity[]): [EnumEntity[], InterfaceEntity[]];
export declare function printInternalInterfacesAndEnums(entity: InterfaceEntity): string;
