"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * service ItemProviderService {
     RangeResponse    RangeItem            (1: RangeRequest req)  #总是按时间倒序
     // 根据时间来请求item信息
     ItemListResponse ItemListByCreateTime (1: RangeRequest req)  #总是按时间倒序
     // 根据ID来请求详情
     ItemListResponse ItemListByID         (1: ItemIDListRequest req)  #按照ID
   }
 *
 * @export
 * @param {string[]} codeLines
 */
function parseService(codeLines, _options) {
    const serviceName = isServiceBlockStart(codeLines[0]).mc;
    const rtn = {
        name: serviceName,
        interfaces: {}
    };
    let i = 1;
    for (; i < codeLines.length; i++) {
        const code = codeLines[i];
        parseServiceInterface(rtn.interfaces, code.trim());
    }
    return rtn;
}
exports.parseService = parseService;
const trapInterfaceRegExp = /^([^\s]+)\s+([^\s]+)\s*(?:(?:\(\s*\d+\s*\:\s*([^\s]+)\s+[^\s]+\s*\))|\(\s*\))[\s,;]?\s*(?:(?:#|\/\/)(.+))?$/;
function parseServiceInterface(interfaces, code) {
    const mc = trapInterfaceRegExp.exec(code);
    if (!mc) {
        return;
    }
    interfaces[mc[2]] = {
        returnType: mc[1],
        inputType: (mc[3] || ''),
        comment: (mc[4] || '').trim()
    };
}
exports.parseServiceInterface = parseServiceInterface;
const trapServiceNameRegExp = /^\s*service\s+([\w_][^\s]*)\s*\{/;
function isServiceBlockStart(code) {
    const mc = trapServiceNameRegExp.exec(code);
    if (mc) {
        return {
            hit: true,
            mc: mc[1]
        };
    }
    return {
        hit: false,
        mc: null
    };
}
exports.isServiceBlockStart = isServiceBlockStart;
