import { RpcEntity, CMDOptions } from '../interfaces';
export declare function print(entity: RpcEntity | undefined, options: CMDOptions, includeMap: {
    [key: string]: RpcEntity;
}): Promise<void>;
/**
 * 输出 enums
 *
 * @export
 * @param {RpcEntity} entity thrift entity
 * @returns {string}
 */
export declare function printEnums(entity: RpcEntity): string;
/**
 * 输出 interfaces
 *
 * @export
 * @param {Pick<RpcEntity, 'interfaces'>} entity thrift entity
 * @returns {string}
 */
export declare function printInterfaces(entity: Pick<RpcEntity, 'interfaces'>): string;
/**
 * 输出 typedef
 *
 * @export
 * @param {RpcEntity} entity
 * @returns {string}
 */
export declare function printTypeDefs(entity: RpcEntity): string;
/**
 * 这个函数用来修复类型是通过 import 导入的名称
 *
 * @export
 * @param {string} content
 * @param {RpcEntity} entity
 * @param {{ [key: string]: RpcEntity }} includeMap
 * @returns {string}
 */
export declare function fixIncludeNamespace(content: string, entity: RpcEntity, includeMap: {
    [key: string]: RpcEntity;
}): string;
export declare function printServices(serviceEntity: RpcEntity['services']): string;
