"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/* istanbul ignore file */
const path = require("path");
const fs = require("fs");
const cp = require("child_process");
const semverCompare_js_1 = require("./semverCompare.js");
// @ts-ignore
// 提示更新，并且创建隐藏文件，已表示检查过了，之后不再提示
function updateNotify(pkg) {
    const cfgFile = path.resolve(__dirname, '.dft-cfg');
    fs.exists(cfgFile, exists => {
        if (!exists) {
            cp.exec(`npm view ${pkg.name} version`, (err, stdout) => {
                fs.writeFile(cfgFile, '', () => { });
                if (err) {
                    return;
                }
                const v = stdout;
                if (/^(0|1-9)\d*\.(0|1-9)\d*\.(0|1-9)\d*$/i.test(v) &&
                    semverCompare_js_1.semverCompare(v, pkg.version) === '>') {
                    console.log(`Tool dts-from-thrift has updated. The newest version is ${v}`);
                }
            });
        }
    });
}
exports.updateNotify = updateNotify;
